#lang racket/base
(require "global.rkt"
         "nums.rkt"
         "reg.rkt"
         "pc.rkt")

(provide jmpi
         jsr
         branch-on
         ldi)

;; jmpi : instruction
(define (jmpi sign digits)
  (set-pc! (collapse sign digits)))

;; jsr : instruction
(define (jsr sign digits)
  (set-reg! (vector-ref digits 1) (get-pc))
  (jmpi sign digits))

;; branch-on : (value value -> bool) -> (instruction)
(define (branch-on cmp)
  (lambda (sign digits)
    (when (cmp (get-reg (vector-ref digits 1)) 0)
      (jmpi sign digits))))

;; ldi : instruction
(define (ldi sign digits)
  (set-reg! (vector-ref digits 1) (collapse sign digits)))

