#lang racket/base
(require "reg.rkt"
         "mem.rkt"
         "pc.rkt"
         "reg-ins0.rkt")

(provide ld/x st/x jmpx mov)

;; ld/x : instruction
(define ld/x
  (make-ld-st/x
    (lambda (x addr)
      (set-reg! x (get-mem addr)))))

;; st/x : instruction
(define st/x
  (make-ld-st/x
    (lambda (x addr)
      (set-mem! addr (get-reg x)))))

;; jmpx : instruction
(define (jmpx sign digits)
  (set-pc! (get-reg (vector-ref digits 2))))

;; mov : instruction
(define (mov sign digits)
  (set-reg! (vector-ref digits 3) (get-reg (vector-ref digits 2))))
